<?php


// -------- Copyright Reserved Tammam Massa  2023 --------//


//date_default_timezone_set("Asia/Damascus");

define("MB", 1048576);

function filterRequest($requestname)
{
  return  htmlspecialchars(strip_tags($_POST[$requestname]));
}

function getAllData($table, $where = null, $values = null,$json=true)
{
    global $con;
    $data = array();
    if($where==null){
        $stmt = $con->prepare("SELECT  * FROM $table ");
    }
    else{
        $stmt = $con->prepare("SELECT  * FROM $table WHERE   $where ");
    }
   
    $stmt->execute($values);
    $data = $stmt->fetchAll(PDO::FETCH_ASSOC);
    $count  = $stmt->rowCount();
    if($json==true){
        if ($count > 0){
            echo json_encode(array("status" => "success", "data" => $data));
        } else {
            echo json_encode(array("status" => "failure"));
        }
        return $count;
    }
    else{
        if ($count > 0){
           return   array("status" => "success","data"=> $data);
        } else{
            return  array("status" => "failure");
        }

    }
    
}

function getData($table, $where = null, $values = null,$json=true)
{
    global $con;
    $data = array();
    $stmt = $con->prepare("SELECT  * FROM $table WHERE   $where ");
    $stmt->execute($values);
    $data = $stmt->fetch(PDO::FETCH_ASSOC);
    $count  = $stmt->rowCount();
    if($json==true){
    if ($count > 0){
        echo json_encode(array("status" => "success", "data" => $data));
    } else {
        echo json_encode(array("status" => "failure"));
    }} 
    else {
    return $count;
}
}


function insertData($table, $data, $json = true)
{
    global $con;
    foreach ($data as $field => $v)
        $ins[] = ':' . $field;
    $ins = implode(',', $ins);
    $fields = implode(',', array_keys($data));
    $sql = "INSERT INTO $table ($fields) VALUES ($ins)";

    $stmt = $con->prepare($sql);
    foreach ($data as $f => $v) {
        $stmt->bindValue(':' . $f, $v);
    }
    $stmt->execute();
    $count = $stmt->rowCount();
    if ($json == true) {
    if ($count > 0) {
        echo json_encode(array("status" => "success"));
    } else {
        echo json_encode(array("status" => "failure"));
    }
  }
    return $count;
}


function updateData($table, $data, $where, $json = true)
{
    global $con;
    $cols = array();
    $vals = array();

    foreach ($data as $key => $val) {
        $vals[] = "$val";
        $cols[] = "`$key` =  ? ";
    }
    $sql = "UPDATE $table SET " . implode(', ', $cols) . " WHERE $where";

    $stmt = $con->prepare($sql);
    $stmt->execute($vals);
    $count = $stmt->rowCount();
    if ($json == true) {
    if ($count > 0) {
        echo json_encode(array("status" => "success"));
    } else {
        echo json_encode(array("status" => "failure"));
    }
    }
    return $count;
}

function deleteData($table, $where, $json = true)
{
    global $con;
    $stmt = $con->prepare("DELETE FROM $table WHERE $where");
    $stmt->execute();
    $count = $stmt->rowCount();
    if ($json == true) {
        if ($count > 0) {
            echo json_encode(array("status" => "success"));
        } else {
            echo json_encode(array("status" => "failure"));
        }
    }
    return $count;
}

function imageUpload($dir,$imageRequest)
{
    global $msgError;
    if(isset($_FILES[$imageRequest])){
        $imagename  = rand(1000, 10000) . $_FILES[$imageRequest]['name'];
        $imagetmp   = $_FILES[$imageRequest]['tmp_name'];
        $imagesize  = $_FILES[$imageRequest]['size'];
        $allowExt   = array("jpg", "png", "gif", "mp3", "pdf","svg");
        $strToArray = explode(".", $imagename);
        $ext        = end($strToArray);
        $ext        = strtolower($ext);
      
        if (!empty($imagename) && !in_array($ext, $allowExt)) {
          $msgError = "EXT";
        }
        if ($imagesize > 2 * MB) {
          $msgError = "size";
        }
        if (empty($msgError)) {
          move_uploaded_file($imagetmp, $dir ."/". $imagename);
          return $imagename;
        } else {
          return "fail";
        }
    } else{
        return 'empty';
    }
  
}



// function imageUpload($dir,$imageRequest)
// {
//     global $msgError;
//     if(isset($_FILES[$imageRequest])){
//         $imagename  = rand(1000, 10000) . $_FILES[$imageRequest]['name'];
//         $imagetmp   = $_FILES[$imageRequest]['tmp_name'];
//         $imagesize  = $_FILES[$imageRequest]['size'];
//         $allowExt   = array("jpg", "png", "gif", "mp3", "pdf");
//         $strToArray = explode(".", $imagename);
//         $ext        = end($strToArray);
//         $ext        = strtolower($ext);
      
//         if (!empty($imagename) && !in_array($ext, $allowExt)) {
//           $msgError = "EXT";
//         }
//         if ($imagesize > 20 * MB) {
//           $msgError = "size";
//         }
//         if (empty($msgError)) {
//           move_uploaded_file($imagetmp,  $dir ."/" . $imagename);
//           return $imagename;
//         } else {
//           return "fail";
//         }
//     } else{
//         return 'empty';
//     }
  
// }
 //multiple pics
// function imageUpload($dir, $imageRequest)
// {
//     global $msgError;

//     if (isset($_FILES[$imageRequest])) {
//         $uploadedFileNames = [];
        
//         foreach ($_FILES[$imageRequest]['name'] as $key => $value) {
//             $imagename  = rand(1000, 10000) . $value;
//             $imagetmp   = $_FILES[$imageRequest]['tmp_name'][$key];
//             $imagesize  = $_FILES[$imageRequest]['size'][$key];
//             $allowExt   = array("jpg", "png", "gif", "mp3", "pdf");

//             $strToArray = explode(".", $imagename);
//             $ext        = end($strToArray);
//             $ext        = strtolower($ext);

//             if (!empty($imagename) && !in_array($ext, $allowExt)) {
//                 $msgError = "EXT";
//             } elseif ($imagesize > 20 * 1024 * 1024) { // 20 * MB
//                 $msgError = "size";
//             }

//             if (empty($msgError)) {
//                 move_uploaded_file($imagetmp, $dir . "/" . $imagename);
//                 $uploadedFileNames[] = $imagename;
//             }
//         }

//         if (!empty($uploadedFileNames)) {
//             return $uploadedFileNames;
//         } else {
//             return "fail";
//         }
//     } else {
//         return 'empty';
//     }
// }



function deleteFile($dir, $imagename)
{
    if (file_exists($dir . "/" . $imagename)) {
        unlink($dir . "/" . $imagename);
    }
}


function checkAuthenticate()
{
    if (isset($_SERVER['PHP_AUTH_USER'])  && isset($_SERVER['PHP_AUTH_PW'])) {
        if ($_SERVER['PHP_AUTH_USER'] != "wael" ||  $_SERVER['PHP_AUTH_PW'] != "wael12345") {
            header('WWW-Authenticate: Basic realm="My Realm"');
            header('HTTP/1.0 401 Unauthorized');
            echo 'Page Not Found';
            exit;
        }
    } else {
        exit;
    }

    // End 
}





function sendEmail($to , $title , $body){
    $header= 'From: admin@tammammassa.com';
    mail($to , $title, $body, $header);
    
    
    
    };


function printFailure($message="none"){
    echo   json_encode(array("status" => "failure","message"=>$message));   
}


function printSuccess($message="none"){
    echo   json_encode(array("status" => "success","message"=>$message));   
}

function result($count){
    if($count>0){

        printSuccess();
         }
     else{
           
        printFailure();
     
     }
}

function sendGCM($title, $message, $topic, $pageid, $pagename)

{





    $url = 'https://fcm.googleapis.com/fcm/send';



    $fields = array(

        "to" => '/topics/' . $topic,

        'priority' => 'high',

        'content_available' => true,



        'notification' => array(

            "body" =>  $message,

            "title" =>  $title,

            "click_action" => "FLUTTER_NOTIFICATION_CLICK",

            "sound" => "default"



        ),

        'data' => array(

            "pageid" => $pageid,

            "pagename" => $pagename

        )



    );





    $fields = json_encode($fields);

    $headers = array(

        'Authorization: key=' . "AAAAFYg6NVk:APA91bFrCZQdjX6s5BS0q56PvakGlpOeHR513H0uXlveoPXAp2RYYo4jYdXg6mz-FuW1b8UZO7CjgvNqpDyxHNIA-sJ0b2clisVSZg-0DHBmcSjK2Il3bj7eM2_AK175fj5L8AlxNsQb",

        'Content-Type: application/json'

    );



    $ch = curl_init();

    curl_setopt($ch, CURLOPT_URL, $url);

    curl_setopt($ch, CURLOPT_POST, true);

    curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);

    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

    curl_setopt($ch, CURLOPT_POSTFIELDS, $fields);



    $result = curl_exec($ch);

    return $result;

    curl_close($ch);

}


function insertNotify($title,$body,$userid,$topic,$pageid,$pagename){
    global $con;
    $stmt=$con->prepare("INSERT INTO `notification` (`notification_title`, `notification_body`, `notification_userid`) VALUES (?,?,?)");
    $stmt->execute(array($title,$body,$userid));
    
sendGCM($title,$body,$topic,$pageid,$pagename);
$count=$stmt->rowCount();
return $count;

}